Index: /palm/trunk/SOURCE/land_surface_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 2231)
+++ /palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 2232)
@@ -1758,34 +1970,82 @@
 !--       wilting point) -> problems with devision by zero)
           DO  k = nzb_soil, nzt_soil
-             t_soil(k,:,:)    = soil_temperature(k)
-             m_soil(k,:,:)    = MAX(soil_moisture(k),m_wilt(:,:))
+             t_soil_h%var_2d(k,:)      = soil_temperature(k)
+             m_soil_h%var_2d(k,:)      = MAX(soil_moisture(k),surf_lsm_h%m_wilt(:))
              soil_moisture(k) = MAX(soil_moisture(k),wilting_point)
           ENDDO
-          t_soil(nzt_soil+1,:,:) = soil_temperature(nzt_soil+1)
+          t_soil_h%var_2d(nzt_soil+1,:) = soil_temperature(nzt_soil+1)
 
 !
 !--       Calculate surface temperature
-          t_surface   = pt_surface * exn
+          t_surface_h%var_1d(:)    = pt_surface * exn
+          surf_lsm_h%pt_surface(:) = pt_surface
 
 !
 !--       Set artifical values for ts and us so that r_a has its initial value 
-!--       for the first time step
-          DO  i = nxlg, nxrg
-             DO  j = nysg, nyng
-                k = nzb_s_inner(j,i)
+!--       for the first time step. Only for interior core domain, not for ghost points
+          DO  m = 1, surf_lsm_h%ns
+             i   = surf_lsm_h%i(m)            
+             j   = surf_lsm_h%j(m)
+             k   = surf_lsm_h%k(m)
+
+             IF ( cloud_physics )  THEN
+                pt1 = pt(k,j,i) + l_d_cp * pt_d_t(k) * ql(k,j,i)
+             ELSE
+                pt1 = pt(k,j,i)
+             ENDIF
+
+!
+!--          Assure that r_a cannot be zero at model start
+             IF ( pt1 == surf_lsm_h%pt_surface(m) )  pt1 = pt1 + 1.0E-10_wp
+
+             surf_lsm_h%us(m)   = 0.1_wp
+             surf_lsm_h%ts(m)   = ( pt1 - surf_lsm_h%pt_surface(m) ) / surf_lsm_h%r_a(m)
+             surf_lsm_h%shf(m)  = - surf_lsm_h%us(m) * surf_lsm_h%ts(m)
+          ENDDO
+!
+!--       Vertical surfaces
+          DO  l = 0, 3
+
+             t_soil_v(l)%var_2d    = 0.0_wp
+             m_soil_v(l)%var_2d    = 0.0_wp
+             m_liq_eb_v(l)%var_1d  = 0.0_wp
+
+!
+!--          Map user settings of T and q for each soil layer
+!--          (make sure that the soil moisture does not drop below the permanent
+!--          wilting point) -> problems with devision by zero)
+             DO  k = nzb_soil, nzt_soil
+                t_soil_v(l)%var_2d(k,:)      = soil_temperature(k)
+                m_soil_v(l)%var_2d(k,:)      = MAX(soil_moisture(k),surf_lsm_v(l)%m_wilt(:))
+                soil_moisture(k) = MAX(soil_moisture(k),wilting_point)
+             ENDDO
+             t_soil_v(l)%var_2d(nzt_soil+1,:) = soil_temperature(nzt_soil+1)
+
+!
+!--          Calculate surface temperature
+             t_surface_v(l)%var_1d(:)   = pt_surface * exn
+             surf_lsm_h%pt_surface(:)   = pt_surface
+
+!
+!--          Set artifical values for ts and us so that r_a has its initial value 
+!--          for the first time step. Only for interior core domain, not for ghost points
+             DO  m = 1, surf_lsm_v(l)%ns
+                i   = surf_lsm_v(l)%i(m)            
+                j   = surf_lsm_v(l)%j(m)
+                k   = surf_lsm_v(l)%k(m)
 
                 IF ( cloud_physics )  THEN
-                   pt1 = pt(k+1,j,i) + l_d_cp * pt_d_t(k+1) * ql(k+1,j,i)
+                   pt1 = pt(k,j,i) + l_d_cp * pt_d_t(k) * ql(k,j,i)
                 ELSE
-                   pt1 = pt(k+1,j,i)
+                   pt1 = pt(k,j,i)
                 ENDIF
 
 !
 !--             Assure that r_a cannot be zero at model start
-                IF ( pt1 == pt(k,j,i) )  pt1 = pt1 + 1.0E-10_wp
-
-                us(j,i)  = 0.1_wp
-                ts(j,i)  = (pt1 - pt(k,j,i)) / r_a(j,i)
-                shf(j,i) = - us(j,i) * ts(j,i)
+                IF ( pt1 == surf_lsm_h%pt_surface(m) )  pt1 = pt1 + 1.0E-10_wp
+
+                surf_lsm_v(l)%us(m)   = 0.1_wp
+                surf_lsm_v(l)%ts(m)   = ( pt1 - surf_lsm_h%pt_surface(m) ) / surf_lsm_v(l)%r_a(m)
+                surf_lsm_v(l)%shf(m)  = - surf_lsm_v(l)%us(m) * surf_lsm_v(l)%ts(m)
              ENDDO
           ENDDO
@@ -1794,16 +2054,61 @@
 !--    Actions for restart runs
        ELSE
-
-          DO  i = nxlg, nxrg
-             DO  j = nysg, nyng
-                k = nzb_s_inner(j,i)                
-                t_surface(j,i) = pt(k,j,i) * exn
-             ENDDO
+!
+!--       Horizontal surfaces
+          DO  m = 1, surf_lsm_h%ns
+             i   = surf_lsm_h%i(m)            
+             j   = surf_lsm_h%j(m)
+             k   = surf_lsm_h%k(m)          
+             t_surface_h%var_1d(m) = pt(k-1,j,i) * exn
           ENDDO
-
-       ENDIF
-
-       DO  k = nzb_soil, nzt_soil
-          root_fr(k,:,:) = root_fraction(k)
+!
+!--       Vertical surfaces
+          DO  l = 0, 3
+!
+!--          Set index offset of surface element, seen from atmospheric grid point 
+             IF ( l == 0 )  THEN 
+                j_off = -1 
+                i_off = 0
+             ELSEIF ( l == 1 )  THEN 
+                j_off = 1 
+                i_off = 0
+             ELSEIF ( l == 2 )  THEN 
+                j_off = 0 
+                i_off = -1
+             ELSEIF ( l == 3 )  THEN 
+                j_off = 0 
+                i_off = 1
+             ENDIF
+             DO  m = 1, surf_lsm_v(l)%ns
+                i   = surf_lsm_v(l)%i(m)            
+                j   = surf_lsm_v(l)%j(m)
+                k   = surf_lsm_v(l)%k(m)          
+                t_surface_v(l)%var_1d(m) = pt(k,j+j_off,i+i_off) * exn
+             ENDDO
+          ENDDO
+
+       ENDIF
+!
+!--    Initialize root fraction
+!--    Horizontal surfaces
+       DO  m = 1, surf_lsm_h%ns
+          i   = surf_lsm_h%i(m)            
+          j   = surf_lsm_h%j(m)
+
+          DO  k = nzb_soil, nzt_soil
+             surf_lsm_h%root_fr(k,m) = root_fraction(k)
+          ENDDO
+       ENDDO
+!
+!--    Vertical surfaces
+       DO  l = 0, 3
+          DO  m = 1, surf_lsm_v(l)%ns
+             i   = surf_lsm_v(l)%i(m)            
+             j   = surf_lsm_v(l)%j(m)
+
+             DO  k = nzb_soil, nzt_soil
+                surf_lsm_v(l)%root_fr(k,m) = root_fraction(k)
+             ENDDO
+          ENDDO
        ENDDO
 
@@ -1843,7 +2148,23 @@
 
           IF ( ANY( root_fraction == 9999999.9_wp ) )  THEN
-             DO  k = nzb_soil, nzt_soil
-                root_fr(k,:,:) = root_distribution(k,veg_type)
-                root_fraction(k) = root_distribution(k,veg_type)
+             DO  m = 1, surf_lsm_h%ns
+                i   = surf_lsm_h%i(m)            
+                j   = surf_lsm_h%j(m)
+
+                DO  k = nzb_soil, nzt_soil
+                   surf_lsm_h%root_fr(k,m) = root_distribution(k,veg_type)
+                   root_fraction(k)    = root_distribution(k,veg_type)
+                ENDDO
+             ENDDO
+             DO  l = 0, 3
+                DO  m = 1, surf_lsm_v(l)%ns
+                   i   = surf_lsm_v(l)%i(m)            
+                   j   = surf_lsm_v(l)%j(m)
+
+                   DO  k = nzb_soil, nzt_soil
+                      surf_lsm_v(l)%root_fr(k,m) = root_distribution(k,veg_type)
+                      root_fraction(k)    = root_distribution(k,veg_type)
+                   ENDDO
+                ENDDO
              ENDDO
           ENDIF
@@ -1877,19 +2198,39 @@
 !--    Map vegetation and soil types to 2D array to allow for heterogeneous 
 !--    surfaces via user interface see below
-       veg_type_2d = veg_type
-       soil_type_2d = soil_type
+!--    First for horizontal surfaces
+       surf_lsm_h%veg_type_2d  = veg_type
+       surf_lsm_h%soil_type_2d = soil_type
 
 !
 !--    Map vegetation parameters to the respective 2D arrays
-       r_canopy_min         = min_canopy_resistance
-       lai                  = leaf_area_index
-       c_veg                = vegetation_coverage
-       g_d                  = canopy_resistance_coefficient
-       lambda_surface_s     = lambda_surface_stable
-       lambda_surface_u     = lambda_surface_unstable
-       f_sw_in              = f_shortwave_incoming
-       z0                   = z0_eb
-       z0h                  = z0h_eb
-       z0q                  = z0q_eb
+       surf_lsm_h%r_canopy_min      = min_canopy_resistance
+       surf_lsm_h%lai               = leaf_area_index
+       surf_lsm_h%c_veg             = vegetation_coverage
+       surf_lsm_h%g_d               = canopy_resistance_coefficient
+       surf_lsm_h%lambda_surface_s  = lambda_surface_stable
+       surf_lsm_h%lambda_surface_u  = lambda_surface_unstable
+       surf_lsm_h%f_sw_in           = f_shortwave_incoming
+       surf_lsm_h%z0                = z0_eb
+       surf_lsm_h%z0h               = z0h_eb
+       surf_lsm_h%z0q               = z0q_eb
+
+!--    Vertical surfaces
+       DO  l = 0, 3
+          surf_lsm_v(l)%veg_type_2d  = veg_type
+          surf_lsm_v(l)%soil_type_2d = soil_type
+
+!
+!--       Map vegetation parameters to the respective 2D arrays
+          surf_lsm_v(l)%r_canopy_min      = min_canopy_resistance
+          surf_lsm_v(l)%lai               = leaf_area_index
+          surf_lsm_v(l)%c_veg             = vegetation_coverage
+          surf_lsm_v(l)%g_d               = canopy_resistance_coefficient
+          surf_lsm_v(l)%lambda_surface_s  = lambda_surface_stable
+          surf_lsm_v(l)%lambda_surface_u  = lambda_surface_unstable
+          surf_lsm_v(l)%f_sw_in           = f_shortwave_incoming
+          surf_lsm_v(l)%z0                = z0_eb
+          surf_lsm_v(l)%z0h               = z0h_eb
+          surf_lsm_v(l)%z0q               = z0q_eb
+       ENDDO
 
 !
@@ -1900,25 +2241,34 @@
 !--    Set flag parameter if vegetation type was set to a water surface. Also
 !--    set temperature to a constant value in all "soil" layers.
-       DO  i = nxlg, nxrg
-          DO  j = nysg, nyng
-             IF ( veg_type_2d(j,i) == 14  .OR.  veg_type_2d(j,i) == 15 )  THEN
-                water_surface(j,i) = .TRUE.
-                t_soil(:,j,i) = t_surface(j,i)
-             ELSEIF ( veg_type_2d(j,i) == 20 )  THEN
-                pave_surface(j,i) = .TRUE.
-                m_soil(:,j,i) = 0.0_wp
-             ENDIF
-
-          ENDDO
+!--    For now, do not set water surface for vertical surfaces
+       DO  m = 1, surf_lsm_h%ns
+          i   = surf_lsm_h%i(m)            
+          j   = surf_lsm_h%j(m)
+
+          IF ( surf_lsm_h%veg_type_2d(m) == 14  .OR.                           &
+               surf_lsm_h%veg_type_2d(m) == 15 )  THEN
+             surf_lsm_h%water_surface(m) = .TRUE.
+             t_soil_h%var_2d(:,m) = t_surface_h%var_1d(m)
+          ELSEIF ( surf_lsm_h%veg_type_2d(m) == 20 )  THEN
+             surf_lsm_h%pave_surface(m) = .TRUE.
+             m_soil_h%var_2d(:,m)            = 0.0_wp
+          ENDIF
+
        ENDDO
 
 !
-!--    Calculate new roughness lengths (for water surfaces only)
+!--    Calculate new roughness lengths (for water surfaces only, i.e. only 
+!-     horizontal surfaces)
        CALL calc_z0_water_surface
 
-       t_soil_p    = t_soil
-       m_soil_p    = m_soil
-       m_liq_eb_p  = m_liq_eb
-       t_surface_p = t_surface
+       t_soil_h_p    = t_soil_h
+       m_soil_h_p    = m_soil_h
+       m_liq_eb_h_p  = m_liq_eb_h
+       t_surface_h_p = t_surface_h
+
+       t_soil_v_p    = t_soil_v
+       m_soil_v_p    = m_soil_v
+       m_liq_eb_v_p  = m_liq_eb_v
+       t_surface_v_p = t_surface_v
 
 
@@ -1926,10 +2276,8 @@
 !--    Store initial profiles of t_soil and m_soil (assuming they are 
 !--    horizontally homogeneous on this PE)
-       hom(nzb_soil:nzt_soil,1,90,:)  = SPREAD( t_soil(nzb_soil:nzt_soil,      &
-                                                nysg,nxlg), 2,                 &
-                                                statistic_regions+1 )
-       hom(nzb_soil:nzt_soil,1,92,:)  = SPREAD( m_soil(nzb_soil:nzt_soil,      &
-                                                nysg,nxlg), 2,                 &
-                                                statistic_regions+1 )
+       hom(nzb_soil:nzt_soil,1,90,:)  = SPREAD( t_soil_h%var_2d(nzb_soil:nzt_soil,1),  &
+                                                2, statistic_regions+1 )
+       hom(nzb_soil:nzt_soil,1,92,:)  = SPREAD( m_soil_h%var_2d(nzb_soil:nzt_soil,1),  & 
+                                                2, statistic_regions+1 )
 
     END SUBROUTINE lsm_init
@@ -1946,79 +2294,175 @@
        IMPLICIT NONE
 
-!
-!--    Allocate surface and soil temperature / humidity
+       INTEGER(iwp) ::  l !< index indicating facing of surface array 
+
+!
+!--    Allocate surface and soil temperature / humidity. Please note, 
+!--    these arrays are allocated according to surface-data structure,
+!--    even if they do not belong to the data type due to the 
+!--    pointer arithmetric (TARGET attribute is not allowed in a data-type). 
 #if defined( __nopointer )
-       ALLOCATE ( m_liq_eb(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( m_liq_eb_p(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( m_soil(nzb_soil:nzt_soil,nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( m_soil_p(nzb_soil:nzt_soil,nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( t_surface(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( t_surface_p(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( t_soil(nzb_soil:nzt_soil+1,nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( t_soil_p(nzb_soil:nzt_soil+1,nysg:nyng,nxlg:nxrg) )
+!
+!--    Horizontal surfaces
+       ALLOCATE ( m_liq_eb_h%var_1d(1:surf_lsm_h%ns)                     )
+       ALLOCATE ( m_liq_eb_h_p%var_1d(1:surf_lsm_h%ns)                   )
+       ALLOCATE ( t_surface_h%var_1d(1:surf_lsm_h%ns)                    )
+       ALLOCATE ( t_surface_h_p%var_1d(1:surf_lsm_h%ns)                  )
+       ALLOCATE ( m_soil_h%var_2d(nzb_soil:nzt_soil,1:surf_lsm_h%ns)     )
+       ALLOCATE ( m_soil_h_p%var_2d(nzb_soil:nzt_soil,1:surf_lsm_h%ns)   )
+       ALLOCATE ( t_soil_h%var_2d(nzb_soil:nzt_soil+1,1:surf_lsm_h%ns)   )
+       ALLOCATE ( t_soil_h_p%var_2d(nzb_soil:nzt_soil+1,1:surf_lsm_h%ns) )
+!
+!--    Vertical surfaces
+       DO  l = 0, 3
+          ALLOCATE ( m_liq_eb_v(l)%var_1d(1:surf_lsm_v(l)%ns)                     )
+          ALLOCATE ( m_liq_eb_v(l)_p%var_1d(1:surf_lsm_v(l)%ns)                   )
+          ALLOCATE ( t_surface_v(l)%var_1d(1:surf_lsm_v(l)%ns)                    )
+          ALLOCATE ( t_surface_v(l)_p%var_1d(1:surf_lsm_v(l)%ns)                  )
+          ALLOCATE ( m_soil_v(l)%var_2d(nzb_soil:nzt_soil,1:surf_lsm_v(l)%ns)     )
+          ALLOCATE ( m_soil_v(l)_p%var_2d(nzb_soil:nzt_soil,1:surf_lsm_v(l)%ns)   )
+          ALLOCATE ( t_soil_v(l)%var_2d(nzb_soil:nzt_soil+1,1:surf_lsm_v(l)%ns)   )
+          ALLOCATE ( t_soil_v(l)_p%var_2d(nzb_soil:nzt_soil+1,1:surf_lsm_v(l)%ns) )
+       ENDDO
 #else
-       ALLOCATE ( m_liq_eb_1(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( m_liq_eb_2(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( m_soil_1(nzb_soil:nzt_soil,nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( m_soil_2(nzb_soil:nzt_soil,nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( t_surface_1(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( t_surface_2(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( t_soil_1(nzb_soil:nzt_soil+1,nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( t_soil_2(nzb_soil:nzt_soil+1,nysg:nyng,nxlg:nxrg) )
+!
+!--    Horizontal surfaces
+       ALLOCATE ( m_liq_eb_h_1%var_1d(1:surf_lsm_h%ns)                   )
+       ALLOCATE ( m_liq_eb_h_2%var_1d(1:surf_lsm_h%ns)                   )
+       ALLOCATE ( t_surface_h_1%var_1d(1:surf_lsm_h%ns)                  )
+       ALLOCATE ( t_surface_h_2%var_1d(1:surf_lsm_h%ns)                  )
+       ALLOCATE ( m_soil_h_1%var_2d(nzb_soil:nzt_soil,1:surf_lsm_h%ns)   )
+       ALLOCATE ( m_soil_h_2%var_2d(nzb_soil:nzt_soil,1:surf_lsm_h%ns)   )
+       ALLOCATE ( t_soil_h_1%var_2d(nzb_soil:nzt_soil+1,1:surf_lsm_h%ns) )
+       ALLOCATE ( t_soil_h_2%var_2d(nzb_soil:nzt_soil+1,1:surf_lsm_h%ns) )
+!
+!--    Vertical surfaces
+       DO  l = 0, 3
+          ALLOCATE ( m_liq_eb_v_1(l)%var_1d(1:surf_lsm_v(l)%ns)                   )
+          ALLOCATE ( m_liq_eb_v_2(l)%var_1d(1:surf_lsm_v(l)%ns)                   )
+          ALLOCATE ( t_surface_v_1(l)%var_1d(1:surf_lsm_v(l)%ns)                  )
+          ALLOCATE ( t_surface_v_2(l)%var_1d(1:surf_lsm_v(l)%ns)                  )
+          ALLOCATE ( m_soil_v_1(l)%var_2d(nzb_soil:nzt_soil,1:surf_lsm_v(l)%ns)   )
+          ALLOCATE ( m_soil_v_2(l)%var_2d(nzb_soil:nzt_soil,1:surf_lsm_v(l)%ns)   )
+          ALLOCATE ( t_soil_v_1(l)%var_2d(nzb_soil:nzt_soil+1,1:surf_lsm_v(l)%ns) )
+          ALLOCATE ( t_soil_v_2(l)%var_2d(nzb_soil:nzt_soil+1,1:surf_lsm_v(l)%ns) )
+       ENDDO
 #endif
 
 !
 !--    Allocate intermediate timestep arrays
-       ALLOCATE ( tm_liq_eb_m(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( tm_soil_m(nzb_soil:nzt_soil,nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( tt_surface_m(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( tt_soil_m(nzb_soil:nzt_soil,nysg:nyng,nxlg:nxrg) )
+!--    Horizontal surfaces
+       ALLOCATE ( tm_liq_eb_h_m%var_1d(1:surf_lsm_h%ns)                  )
+       ALLOCATE ( tt_surface_h_m%var_1d(1:surf_lsm_h%ns)                 )
+       ALLOCATE ( tm_soil_h_m%var_2d(nzb_soil:nzt_soil,1:surf_lsm_h%ns)  )
+       ALLOCATE ( tt_soil_h_m%var_2d(nzb_soil:nzt_soil,1:surf_lsm_h%ns)  ) 
+!
+!--    Horizontal surfaces
+       DO  l = 0, 3
+          ALLOCATE ( tm_liq_eb_v_m(l)%var_1d(1:surf_lsm_v(l)%ns)                  )
+          ALLOCATE ( tt_surface_v_m(l)%var_1d(1:surf_lsm_v(l)%ns)                 )
+          ALLOCATE ( tm_soil_v_m(l)%var_2d(nzb_soil:nzt_soil,1:surf_lsm_v(l)%ns)  )
+          ALLOCATE ( tt_soil_v_m(l)%var_2d(nzb_soil:nzt_soil,1:surf_lsm_v(l)%ns)  )
+       ENDDO 
+!
+!--    Allocate skin-surface temperature
+       ALLOCATE ( surf_lsm_h%pt_surface(1:surf_lsm_h%ns) )
+       DO  l = 0, 3
+          ALLOCATE ( surf_lsm_v(l)%pt_surface(1:surf_lsm_v(l)%ns) )
+       ENDDO 
 
 !
 !--    Allocate 2D vegetation model arrays
-       ALLOCATE ( alpha_vg(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( building_surface(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( c_liq(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( c_veg(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( f_sw_in(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( ghf_eb(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( gamma_w_sat(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( g_d(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( lai(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( l_vg(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( lambda_surface_u(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( lambda_surface_s(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( m_fc(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( m_res(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( m_sat(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( m_wilt(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( n_vg(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( pave_surface(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( qsws_eb(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( qsws_soil_eb(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( qsws_liq_eb(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( qsws_veg_eb(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( rad_net_l(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( r_a(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( r_canopy(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( r_soil(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( r_soil_min(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( r_s(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( r_canopy_min(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( shf_eb(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( soil_type_2d(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( veg_type_2d(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( water_surface(nysg:nyng,nxlg:nxrg) )
-
-       water_surface = .FALSE.
-       pave_surface  = .FALSE.
-
+!--    Horizontal surfaces
+       ALLOCATE ( surf_lsm_h%alpha_vg(1:surf_lsm_h%ns)         )
+       ALLOCATE ( surf_lsm_h%building_surface(1:surf_lsm_h%ns) )
+       ALLOCATE ( surf_lsm_h%c_liq(1:surf_lsm_h%ns)            )
+       ALLOCATE ( surf_lsm_h%c_veg(1:surf_lsm_h%ns)            )
+       ALLOCATE ( surf_lsm_h%f_sw_in(1:surf_lsm_h%ns)          )
+       ALLOCATE ( surf_lsm_h%ghf_eb(1:surf_lsm_h%ns)           )
+       ALLOCATE ( surf_lsm_h%gamma_w_sat(1:surf_lsm_h%ns)      )
+       ALLOCATE ( surf_lsm_h%g_d(1:surf_lsm_h%ns)              )
+       ALLOCATE ( surf_lsm_h%lai(1:surf_lsm_h%ns)              )
+       ALLOCATE ( surf_lsm_h%l_vg(1:surf_lsm_h%ns)             )
+       ALLOCATE ( surf_lsm_h%lambda_surface_u(1:surf_lsm_h%ns) )
+       ALLOCATE ( surf_lsm_h%lambda_surface_s(1:surf_lsm_h%ns) )
+       ALLOCATE ( surf_lsm_h%m_fc(1:surf_lsm_h%ns)             )
+       ALLOCATE ( surf_lsm_h%m_res(1:surf_lsm_h%ns)            )
+       ALLOCATE ( surf_lsm_h%m_sat(1:surf_lsm_h%ns)            )
+       ALLOCATE ( surf_lsm_h%m_wilt(1:surf_lsm_h%ns)           )
+       ALLOCATE ( surf_lsm_h%n_vg(1:surf_lsm_h%ns)             )
+       ALLOCATE ( surf_lsm_h%pave_surface(1:surf_lsm_h%ns)     )
+       ALLOCATE ( surf_lsm_h%qsws_eb(1:surf_lsm_h%ns)          )
+       ALLOCATE ( surf_lsm_h%qsws_soil_eb(1:surf_lsm_h%ns)     )
+       ALLOCATE ( surf_lsm_h%qsws_liq_eb(1:surf_lsm_h%ns)      )
+       ALLOCATE ( surf_lsm_h%qsws_veg_eb(1:surf_lsm_h%ns)      )
+       ALLOCATE ( surf_lsm_h%rad_net_l(1:surf_lsm_h%ns)        )
+       ALLOCATE ( surf_lsm_h%r_a(1:surf_lsm_h%ns)              )
+       ALLOCATE ( surf_lsm_h%r_canopy(1:surf_lsm_h%ns)         )
+       ALLOCATE ( surf_lsm_h%r_soil(1:surf_lsm_h%ns)           )
+       ALLOCATE ( surf_lsm_h%r_soil_min(1:surf_lsm_h%ns)       )
+       ALLOCATE ( surf_lsm_h%r_s(1:surf_lsm_h%ns)              )
+       ALLOCATE ( surf_lsm_h%r_canopy_min(1:surf_lsm_h%ns)     )
+       ALLOCATE ( surf_lsm_h%shf_eb(1:surf_lsm_h%ns)           )
+       ALLOCATE ( surf_lsm_h%soil_type_2d(1:surf_lsm_h%ns)     )
+       ALLOCATE ( surf_lsm_h%veg_type_2d(1:surf_lsm_h%ns)      )
+       ALLOCATE ( surf_lsm_h%water_surface(1:surf_lsm_h%ns)    )
+
+       surf_lsm_h%water_surface = .FALSE.
+       surf_lsm_h%pave_surface  = .FALSE.
+!
+!--    Vertical surfaces
+       DO  l = 0, 3
+          ALLOCATE ( surf_lsm_v(l)%alpha_vg(1:surf_lsm_v(l)%ns)         )
+          ALLOCATE ( surf_lsm_v(l)%building_surface(1:surf_lsm_v(l)%ns) )
+          ALLOCATE ( surf_lsm_v(l)%c_liq(1:surf_lsm_v(l)%ns)            )
+          ALLOCATE ( surf_lsm_v(l)%c_veg(1:surf_lsm_v(l)%ns)            )
+          ALLOCATE ( surf_lsm_v(l)%f_sw_in(1:surf_lsm_v(l)%ns)          )
+          ALLOCATE ( surf_lsm_v(l)%ghf_eb(1:surf_lsm_v(l)%ns)           )
+          ALLOCATE ( surf_lsm_v(l)%gamma_w_sat(1:surf_lsm_v(l)%ns)      )
+          ALLOCATE ( surf_lsm_v(l)%g_d(1:surf_lsm_v(l)%ns)              )
+          ALLOCATE ( surf_lsm_v(l)%lai(1:surf_lsm_v(l)%ns)              )
+          ALLOCATE ( surf_lsm_v(l)%l_vg(1:surf_lsm_v(l)%ns)             )
+          ALLOCATE ( surf_lsm_v(l)%lambda_surface_u(1:surf_lsm_v(l)%ns) )
+          ALLOCATE ( surf_lsm_v(l)%lambda_surface_s(1:surf_lsm_v(l)%ns) )
+          ALLOCATE ( surf_lsm_v(l)%m_fc(1:surf_lsm_v(l)%ns)             )
+          ALLOCATE ( surf_lsm_v(l)%m_res(1:surf_lsm_v(l)%ns)            )
+          ALLOCATE ( surf_lsm_v(l)%m_sat(1:surf_lsm_v(l)%ns)            )
+          ALLOCATE ( surf_lsm_v(l)%m_wilt(1:surf_lsm_v(l)%ns)           )
+          ALLOCATE ( surf_lsm_v(l)%n_vg(1:surf_lsm_v(l)%ns)             )
+          ALLOCATE ( surf_lsm_v(l)%pave_surface(1:surf_lsm_v(l)%ns)     )
+          ALLOCATE ( surf_lsm_v(l)%qsws_eb(1:surf_lsm_v(l)%ns)          )
+          ALLOCATE ( surf_lsm_v(l)%qsws_soil_eb(1:surf_lsm_v(l)%ns)     )
+          ALLOCATE ( surf_lsm_v(l)%qsws_liq_eb(1:surf_lsm_v(l)%ns)      )
+          ALLOCATE ( surf_lsm_v(l)%qsws_veg_eb(1:surf_lsm_v(l)%ns)      )
+          ALLOCATE ( surf_lsm_v(l)%rad_net_l(1:surf_lsm_v(l)%ns)        )
+          ALLOCATE ( surf_lsm_v(l)%r_a(1:surf_lsm_v(l)%ns)              )
+          ALLOCATE ( surf_lsm_v(l)%r_canopy(1:surf_lsm_v(l)%ns)         )
+          ALLOCATE ( surf_lsm_v(l)%r_soil(1:surf_lsm_v(l)%ns)           )
+          ALLOCATE ( surf_lsm_v(l)%r_soil_min(1:surf_lsm_v(l)%ns)       )
+          ALLOCATE ( surf_lsm_v(l)%r_s(1:surf_lsm_v(l)%ns)              )
+          ALLOCATE ( surf_lsm_v(l)%r_canopy_min(1:surf_lsm_v(l)%ns)     )
+          ALLOCATE ( surf_lsm_v(l)%shf_eb(1:surf_lsm_v(l)%ns)           )
+          ALLOCATE ( surf_lsm_v(l)%soil_type_2d(1:surf_lsm_v(l)%ns)     )
+          ALLOCATE ( surf_lsm_v(l)%veg_type_2d(1:surf_lsm_v(l)%ns)      )
+          ALLOCATE ( surf_lsm_v(l)%water_surface(1:surf_lsm_v(l)%ns)    )
+
+          surf_lsm_v(l)%water_surface = .FALSE.
+          surf_lsm_v(l)%pave_surface  = .FALSE.
+       ENDDO
+   
 #if ! defined( __nopointer )
 !
 !--    Initial assignment of the pointers
-       t_soil    => t_soil_1;    t_soil_p    => t_soil_2
-       t_surface => t_surface_1; t_surface_p => t_surface_2
-       m_soil    => m_soil_1;    m_soil_p    => m_soil_2
-       m_liq_eb  => m_liq_eb_1;  m_liq_eb_p  => m_liq_eb_2
+!--    Horizontal surfaces
+       t_soil_h    => t_soil_h_1;    t_soil_h_p    => t_soil_h_2
+       t_surface_h => t_surface_h_1; t_surface_h_p => t_surface_h_2
+       m_soil_h    => m_soil_h_1;    m_soil_h_p    => m_soil_h_2
+       m_liq_eb_h  => m_liq_eb_h_1;  m_liq_eb_h_p  => m_liq_eb_h_2
+!
+!--    Vertical surfaces
+       t_soil_v    => t_soil_v_1;    t_soil_v_p    => t_soil_v_2
+       t_surface_v => t_surface_v_1; t_surface_v_p => t_surface_v_2
+       m_soil_v    => m_soil_v_1;    m_soil_v_p    => m_soil_v_2
+       m_liq_eb_v  => m_liq_eb_v_1;  m_liq_eb_v_p  => m_liq_eb_v_2
 #endif
 
@@ -2043,5 +2487,5 @@
                                   conserve_water_content,                      &
                                   f_shortwave_incoming, field_capacity,        & 
-                                  hydraulic_conductivity,                      &
+                                  aero_resist_kray, hydraulic_conductivity,                      &
                                   lambda_surface_stable,                       &
                                   lambda_surface_unstable, leaf_area_index,    &
@@ -2087,14 +2531,16 @@
 !> temperature and water content.
 !------------------------------------------------------------------------------!
-    SUBROUTINE lsm_soil_model
+    SUBROUTINE lsm_soil_model( horizontal, l )
 
 
        IMPLICIT NONE
 
-       INTEGER(iwp) ::  i   !< running index
-       INTEGER(iwp) ::  j   !< running index
-       INTEGER(iwp) ::  k   !< running index
-
-       REAL(wp)     :: h_vg !< Van Genuchten coef. h
+       INTEGER(iwp) ::  k       !< running index
+       INTEGER(iwp) ::  l       !< surface-data type index indication facing
+       INTEGER(iwp) ::  m       !< running index
+
+       LOGICAL      ::  horizontal !< flag indication horizontal wall, required to set pointer accordingly
+
+       REAL(wp)     ::  h_vg !< Van Genuchten coef. h
 
        REAL(wp), DIMENSION(nzb_soil:nzt_soil) :: gamma_temp,  & !< temp. gamma
